#!/usr/bin/php -q
<?php
// vim: set noexpandtab tabstop=2 softtabstop=2 shiftwidth=2:

// Updated: Xymph <tm@gamers.org>
require_once('GbxRemote.inc.php');
require_once('rpcutils.inc.php');

$client = connectServer();
if (!$client->query('system.listMethods'))
	clientError($client, 'Cannot list methods');
$methods = $client->getResponse();

if (!$client->query('GetVersion'))
	clientError($client, 'Cannot get version');
$version = $client->getResponse();
switch ($version['Name']) {
	case 'TmOriginal':
		$title = 'TrackMania Original';
		break;
	case 'TmSunrise':
		$title = 'TrackMania Sunrise';
		break;
	case 'TmNationsESWC':
		$title = 'TrackMania Nations';
		break;
	case 'TmUnited':
		$title = 'TrackMania United';
		break;
	case 'TmForever':
		$title = 'TrackMania Forever';
		break;
	default: // ManiaPlanet
		$title = $version['Name'];
		break;
}
$api = '';
if (isset($version['ApiVersion']))
	$api = $version['ApiVersion'];

header('Content-Type: text/html; charset=utf-8');

echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
echo "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n<head>\n";
echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
echo "<title>$title methods".($api != '' ? ' - API version '.$api : '')."</title>\n";
echo "</head>\n<body>\n";

echo "<h1>Available methods:</h1>\n";

echo "<ul>\n";
foreach ($methods as $m) {
	echo '<li><b>' . $m . "</b><br/>\n";
	if ($client->query('system.methodSignature', $m)) {
		$signatures = $client->getResponse();
	} else {
		$signatures = array();
		echo "<font color=\"red\">{error in signature}</font><br/>\n";
	}
	if ($client->query('system.methodHelp', $m)) {
		$help = $client->getResponse();
	} else {
		$help = "<font color=\"red\">{no help}</font>";
	}

	foreach ($signatures as $sig) {
		$is_retval = 1;
		$is_firstarg = 1;
		foreach ($sig as $argtype) {
			if ($is_retval) {
				echo $argtype . ' ' . $m . '(';
				$is_retval = 0;
			} else {
				if (!$is_firstarg) {
					echo ', ';
				}
				echo $argtype;
				$is_firstarg = 0;
			}
		}
		echo ")<br/>\n";
	}
	echo '<font color="0x113355">';
	echo $help;
	echo "</font></li>\n";
}
echo "</ul>\n";

$client->Terminate();

echo "</body>\n</html>\n";
flush();
?>
